<?php

/*
 * Plugin Name: Stacks Mobile App Builder
 * Author: Stacks
 * Author URI: stacksmarket.co
 * Description: Enjoy the fast and easy experience of building your Ecommerce mobile application
 * Version: 4.7.1
 */
class stacks_app_builder {

    public function __construct() {
        add_action('after_setup_theme', array($this, 'initialize'));
        register_activation_hook(__FILE__, array($this, 'stacks_app_activate'));
    }

    public function initialize() {
        require_once 'helper_functions.php';
        require_once 'api/main.php';
        require_once 'modules/main.php';
    }

    /**
     * Make sure that there is no old versions of Stacks Plugin that is active, this should prevent conflicts
     *
     * @param [type] $plugin
     * @return void
     */
    public function stacks_app_activate() {
        $all_plugins = get_plugins();
        foreach ($all_plugins as $key => $value) {
            if($value['Name'] == 'Stacks App') {
                if(is_plugin_active($key)) {
                    deactivate_plugins( $key );
                }
            }
        }
        flush_rewrite_rules();
    }
}

new stacks_app_builder();
